/* 
 * Page PlayerFeatures
 * 
 */

"use strict";

var btPFSend = null;
var btPFLocNext = null;
var avatarPseudo = null;
var InitPlayerFeatures_stgyCallMsgBulk = null;

var fieldAzimuth = null;
var fieldLocX = null;
var fieldLocY = null;

var allTiles = null;
var availableTile=[];
var selectedTile = 0;

function PlayerFeatures_init() {
    btPFSend = document.getElementById("btPFNext");
    btPFLocNext = document.getElementById("btPLocNext");
    avatarPseudo = document.getElementById("avatarPseudo");
    if(btPFSend) 
        btPFSend.addEventListener("click", PlayerFeatures__onSendAvatar, false);
    
    fieldAzimuth = document.getElementById("Azimuth");
    fieldLocX = document.getElementById("LocX");
    fieldLocY = document.getElementById("LocY");
    if(btPFLocNext) 
        btPFLocNext.addEventListener("click", PlayerFeatures__onSendLoc, false);
    
    allTiles = document.querySelectorAll("#Localization table td");
    availableTile=[];
    selectedTile = 0;
    
};

function PlayerFeatures_InitPlayerFeatures(msgBulk)
{
    InitPlayerFeatures_stgyCallMsgBulk = msgBulk;
    var pseudo = msgBulk.stgyCall.argsRef.avatar.pseudo;
    avatarPseudo.value = pseudo;
    // visualise la couleur du joueur
    var bc = msgBulk.stgyCall.argsRef.avatar.argbBackColor;
    var colorA = parseInt("0x"+bc["A"]); colorA = parseFloat(colorA/255);
    var colorR = parseInt("0x"+bc["R"]);
    var colorG = parseInt("0x"+bc["G"]);
    var colorB = parseInt("0x"+bc["B"]);
    var hexCol = "rgba("+colorR+","+colorG+","+colorB+","+colorA+")";
    var cons = document.getElementById("Console");
    if(cons) {cons.style.background = hexCol;}
};

function PlayerFeatures_InitPlayerLocalization(msgBulk)
{
    InitPlayerFeatures_stgyCallMsgBulk = msgBulk;
    //> Params to retrieve: array of tiles with values in 0..143, x, y, azimuth
    availableTile= msgBulk.stgyCall.argsIn.availableTiles;
    selectedTile = (msgBulk.stgyCall.argsRef.locX-1) + (msgBulk.stgyCall.argsRef.locY-1)*12;
    var azimuth = msgBulk.stgyCall.argsRef.azimuth;
    fieldAzimuth.selectedIndex = azimuth==="North"?0:(azimuth==="East"?1:(azimuth==="South"?2:3));
    PlayerFeatures__refreshTilesView();
};

function PlayerFeatures__selectTiles(evt)
{
    //In the handler, 'this' is the table cell
    var locX  = this.cellIndex + 1;  // the + 1 is to give a 1 based index
    var locY = this.parentNode.rowIndex + 1;
    selectedTile = (locX-1) + (locY-1)*12;
    PlayerFeatures__refreshTilesView();
};
function PlayerFeatures__refreshTilesView()
{
    for (var i = 0; i < allTiles.length; i++) {
        var x = 1+(i%12); var y=1+Math.floor(i/12);
        //
        // "~" is an operator that floors, inverts and subtracts 1 from a number. 
        // indexOf returns -1 if it fails, so "~" turns -1 into "0". 
        // using "!!" turns numbers into boleans (!!0===false)
        if(!!~availableTile.indexOf(i)){ 
            allTiles[i].innerText=x+":"+y;
            if(i===selectedTile) {
                allTiles[i].className="Sel";
            }else{
                allTiles[i].className="Avail";
                allTiles[i].addEventListener("click", PlayerFeatures__selectTiles, false);
            }
        }else{
            allTiles[i].className="";
            allTiles[i].innerText=" ";
            allTiles[i].removeEventListener("click", PlayerFeatures__selectTiles, false);
        }
    }
}

function PlayerFeatures__onSendAvatar()
{
    var msgBulk = DR2D_WSAPI.extractReplyFromCall(InitPlayerFeatures_stgyCallMsgBulk);
    msgBulk.stgyReply.argsRef.avatar.pseudo = avatarPseudo.value;
    DR2D_WSAPI.sendReply(msgBulk);
    
    waitForPlayerLocation();
}
function PlayerFeatures__onSendLoc()
{
    var msgBulk = DR2D_WSAPI.extractReplyFromCall(InitPlayerFeatures_stgyCallMsgBulk);
    msgBulk.stgyReply.argsRef.locX = 1+(selectedTile%12);
    msgBulk.stgyReply.argsRef.locY = 1+Math.floor(selectedTile/12);
    msgBulk.stgyReply.argsRef.azimuth = fieldAzimuth[fieldAzimuth.selectedIndex].value;
    DR2D_WSAPI.sendReply(msgBulk);
    
    waitForRequireCartouche();
}
